;up up down
;sensenstahl
;www.sensenstahl.com
;fasm 1.69.31
;listening: iotunn - access all worlds

;#3 in the series. not re-inventing the wheel but i had fun
;with (new) design elements nonetheless
;( + without having to think about the use of text ;) )

;i am really happy with this one

;and after quite some time this is
;also a heavier commented source

org 100h
use16

;assuming: cx = 255 ax = bx = 0

start:   push 0a000h ;vga
         pop es
         push 08000h ;buffer
         pop ds
         mov al,13h  ;320*200*256
         int 10h

;color:   0                 127                255
;       black -> green -> yellow -> orange -> black

        mov dx,0x3C9
        xor cx,cx
pal:
;        shr al,1
;        shrd ax,cx,17 ;Z
;        shrd ax,cx,18
        mov al,bl ;X Y
;        xor ax,ax

        out dx,al ;r

;        shr al,1
        shrd ax,cx,17 ;X
;        shrd ax,cx,18 ;Y
;        mov al,bl ;Z
;        xor ax,ax


        out dx,al ;g

        shr al,1 ;X Z
;        shl al,1 ;Y
;        shrd ax,cx,17        
;        mov al,bl
;        xor ax,ax

        out dx,al ;b

        cmp bh,ch;0
        jne pal2

        cmp cl,64
        jb allright
        inc bx
        allright:

        inc cx
        cmp cl,127
        jne pal
        inc bh

pal2:   cmp cl,63
        ja allright2
        dec bx
        allright2:
        loop pal

main:

;ch = 0 here each frame
mov cl,162 ;number of (theorerical) solids

;bx > 0 here
;black bar + grid on 1st layer over background
;using pos (bx) + call saves 3b compared to 2x individual code
mov bx,cx ;pos of black bar/grid
call blk  ;jmp

;create shapes on the 2nd layer over the background
;the shapes are drawn within 4 loops by basically
;moving the previously created shape starting with
;a diagonal line:
;
;   [1]        [2]          [3]            [4]
;
;   1          1             1            1444
;    1         21           321          321444
;     1        221         33221        33221444
;      1       2221       3332221      3332221444
;               222       3333222      3333222444
;                22       3333322      3333322444
;                 2       3333332      3333332444
;                          33333        33333444
;                           333          333444
;                            3            3444
;
;   draw       move        move           move
;   line       down      down+left        rite

solid:
imul di,cx,107 ;over 127 = +1b
               ;random enough and no identical
               ;start values needed each frame
rol di,cl      ;a bit more random
test cl,00000001b ;every 2nd thing on 2nd layer
jnz nay
add di,word[bp] ;add movement (additional speed)
nay:
add di,word[bp] ;add movement (basic speed)

mov dx,di       ;prepare size work
                ;the sizes get smaller
                ;while the solids fly up
                ;a bit choppy but oh well ...
shr dx,12       ;make (step) size
                ;based on y value of pos (approx)
inc dx          ;never 0
mov dh,dl       ;save size
                ;dl is used right away [2]

thing2:
movzx bx,dh     ;set initial size [1]

thing1:
mov ax,di       ;basic color (ah is relevant part)
                ;based on y of position (approx)

add ah,cl       ;make color for each solid a bit more indivual

imul si,bx,320  ;starting point
add si,di       ;add movement
mov ch,dh       ;set step size [3]
doit2:
add ah,ch;3;ch     ;change color for shading
                ;ch would save 1b but steps are not smooth
mov al,dh       ;set step size [4]
doit:
mov byte[ds:bx+si],ah ;draw the pixel

inc bx    ;move right to make full shape
dec al    ;next step
jnz doit  ;do full size [4]

sub bl,dh  ;sub sideway movement so
           ;things continue w/o error
sub si,319 ;move up to draw line
dec ch     ;next step
jnz doit2  ;draw full size [3]

dec bx     ;draw a diagonal line
jnz thing1 ;draw full size [1]
mov ax,320 ;save a few bytes below
           ;outside of solids loop
add di,ax;320 ;move down
dec dl     ;shrink size to draw solid
jnz thing2 ;until done [2]

neeh:
loop solid ;draw all shapes

;managing movement/colors
sub word[bp],ax;320 ;for movement of objects
                    ;and bg color

mov si,word[bp+2] ;get pos of glassbar
inc si            ;move to the right
cmp si,ax;320     ;flawless reset if needed
jnae kk           ;reset not needed
xor si,si         ;reset
kk:
mov word[bp+2],si ;save new pos

;tradional glassbar, 3rd layer over background
;pos = si from above
;cx = bx = dl = 0
glass2:
mov bl,70 ;width of the glass

glass1:
;mov dl,byte[ds:bx+si+70] ;get pixel
;mov byte[ds:bx+si],dl    ;set it on new pos
                         ;for glass/reflection

mov dl,byte[ds:bx+si]
mov byte[ds:bx+si-327],dl   ;makes a small error section
                            ;on the bottom because of the
                            ;buffer "behind" the pal bars
                            ;but that is a ok trade for
                            ;having a better looking glass fx
dec bx
jnz glass1
add si,319;320 ;move down
               ;diagonal bar fits better
jnc glass2     ;draw all the way down

;bx = 0
;draw black bar + grid on 3rd layer over all objects
mov bl,127 ;pos of black bar/grid
call blk   ;jmp

;create faked twisters on 4th layer
;based on the code of my 64b intro "twist-o-fake"
;si = 2 coming from called blk routine above
mov ax,si;4         ;thickness of twister
nexto:
imul dx,word[bp+1],2  ;color ;works here (tm)
mov di,ax             ;set thickness of trister
bar2:
imul si,ax,8          ;space between twisters
add si,di             ;add pos/thickness of twister
bar3:
inc dx                ;color works a.k.a. 1b does all
                      ;the mysterious magic
                      ;that creates the slow twister
mov byte[ds:si+64],dl ;draw the pixel
add si,319            ;move diagonal downwards
jnc bar3              ;until rock bottom
dec di                ;and until
jnz bar2              ;whole thickness done
inc ax                ;next twister is
inc ax                ;thiccer
cmp al,10             ;max size of twister
jna nexto             ;do all twisters

;slow down via vsync as usual
mov dx,3dah
;vsync1:     ;not needed for this one
;in al,dx
;test al,8
;jnz vsync1
vsync2:
in al,dx
test al,8
jz vsync2

;flip
;cx = bx = ah = 0 here
;mov cx,320*132;9600h
mov ch,0a5h;96h
mov di,320*34
flip:
mov al,ch           ;color works
sub al,byte[bp+1]   ;make color cycle
xchg al,byte[ds:di] ;grab + delete vscreen
stosb               ;drop to vga + inc di
loop flip

         in al,60h            ;read keyboard buffer
         dec ax               ;ESC?
         jnz main             ;no, so go on

;draw black bars + grid, see the 2 calls above
;bx = x pos of bar/grid
blk:
mov di,20 ;width of bar / grid*2
blk1:
mov byte[ds:bx+di+21],ch;0 ;black bar
imul si,di,2               ;spring yard zone
mov byte[ds:bx+si],ch      ;grid
dec di
jnz blk1
add bx,319                 ;diagonal it beautiful
jnc blk

breaker: ret  ;halt!